;| Reaktor fr Konstruktionslinien
-------------------------------------------------------------------------------

ndert bei Aufruf der Befehle KLINIE oder STRAHL die aktuellen
Zeichnen-Eigenschaftswerte und setzt sie wieder zurck, sobald
der Befehl beendet oder abgebrochen wird.

Entsprechendes Tutorial hierfr siehe -->
http://www.visuallisp-tutorial.mapcar.net/layreactor.html
von Axel "mapcar" Strube-Zettler

Mithilfe der seit AutoCAD 2004 integrierten Werkzeugpaletten
kann man dort direkt Eingenschaftswerte setzen. Somit wre dieses Tool
berflssig, es sei denn, man arbeitet mit Tastaturbefehlen und/oder
Mengruppen

-------------------------------------------------------------------------------
Copyright (C) 2007 Rolf Wischnewski
www.CADmaro.de
-------------------------------------------------------------------------------
FREEWARE:
Dieser Quellcode darf unbegrenzt und fr jeden Zweck verwendet werden, sofern
keine Gebhr erhoben wird. Der Quellcode darf weiterhin nach eigenen
Bedrfnissen anpasst, verbessert, kopiert und weitergegeben werden. Der
Urheberrechtshinweis darf nicht entfernt werden.
-------------------------------------------------------------------------------

Globale Variablen: *reactor-klprop* , *MyKLprops* , *MyKLoldProps*
|;

(vl-load-com)

;;; Reaktor starten
(defun c:klas ()
  (setq *MyKLprops*
         (list '(LayerPlot . :vlax-false)
               '("clayer" . "KonLin")
               '("cecolor" . "21")
               '("celtype" . "Continuous")
               '("celweight" . 0)
               '("celtscale" . 1)
         )
  )
  (:RC-initCommandReactor
    '*reactor-klprop*
    '((start . :RC-Start>ChangeProp) (end . :RC-End>ChangeProp))
  )
  (prompt
    ">>> CADmaro Mitteilung: <<<\n>>> Automatische Eigenschaftswerte fr Konstruktionslinien AKTIVIERT <<<"
  )
  (prin1)
)

;;; Reaktor beenden
(defun c:klae ()
  (setq *MyKLprops* nil)
  (if (= (type *reactor-klprop*) 'vlr-command-reactor)
    (progn
      (vlr-remove *reactor-klprop*)
      (prompt
        "\n>>> CADmaro Mitteilung: <<<\n>>> Automatische Eigenschaftswerte fr Konstruktionslinien DEAKTIVIERT <<<"
      )
    )
    (prompt
      "\n>>> CADmaro Mitteilung: <<<\n>>> Reaktor Konstruktionslinien nicht vorhanden <<<"
    )
  )
  (prin1)
)

;;;Initialisierung eines Command-Reactors
(defun :RC-initCommandReactor (#SymEventName #asp)
  (if (= (type (eval #SymEventName)) 'vlr-command-reactor)
    (vlr-remove (eval #SymEventName))
  )
  (set #SymEventName
       (vlr-command-reactor
         (vl-symbol-name #SymEventName)
         (list (cons :vlr-commandwillstart (:L-ga 'start #asp))
               (cons :vlr-commandended (:L-ga 'end #asp))
               (cons :vlr-commandcancelled
                     (cond ((:L-ga 'cancel #asp))
                           ((:L-ga 'end #asp))
                     )
               )
               (cons :vlr-commandfailed
                     (cond ((:L-ga 'failed #asp))
                           ((:L-ga 'end #asp))
                     )
               )
         )
       )
  )
)

;;; Callback-Funktion bei Command-Start
(defun :RC-Start>ChangeProp (#retyp #comname)
  (cond ((member (car #comname) '("XLINE" "RAY"))
         (setq *MyKLoldProps*
                (mapcar '(lambda (a) (cons a (getvar a)))
                        '("clayer"
                          "cecolor"
                          "celtype"
                          "celweight"
                          "celtscale"
                         )
                )
         )
         (if (:L-DotPairp-eachLst *MyKLprops*)
           (progn (vla-put-plottable
                    (:LY-ADDNEWLAYER (:L-ga "clayer" *MyKLprops*))
                    (:L-ga 'LayerPlot *MyKLprops*)
                  )
                  (mapcar '(lambda (a) (setvar (car a) (cdr a)))
                          (cdr *MyKLprops*)
                  )
           )
         )
        )
  )
)

;;; Callback-Funktion bei Command-End
(defun :RC-End>ChangeProp (#retyp #comname)
  (cond ((and (member (car #comname) '("XLINE" "RAY"))
              *MyKLoldProps*
         )
         (mapcar '(lambda (a) (setvar (car a) (cdr a)))
                 *MyKLoldProps*
         )
         (setq *MyKLoldProps* nil)
        )
  )
)

;;; **** F U N C T I O N S  ****
;;;------------------------------

;;; Rckgabe eines Key-Wertes von einer Assoziationsliste
(defun :L-ga (#gc #lst) (cdr (assoc #gc #lst)))

;;; Erstellt einen neuen Layer, sofern nicht vorh. und
;;; Rckgabe des Active-X Layerobjektes
(defun :ly-addnewlayer (#layername)
  (if (snvalid #layername)
    (vlax-invoke-method
      (vla-get-layers
        (vla-get-activedocument (vlax-get-acad-object))
      )
      'add
      #layername
    )
  )
)

;;; Prft ob eine Liste eine Assoziationsliste ist
(defun :L-DotPairp (#lst)
  (and (vl-consp #LST) (null (vl-list-length #LST)))
)

;;; Prft ob eine Liste aus Assoziationslisten besteht
(defun :L-DotPairp-eachLst (#alst)
  (vl-every ':L-DotPairp #alst)
)
